-------------------------------------------
--- Author: Ketho (EU-Boulderfist)		---
--- License: Public Domain				---
--- Created: 2011.05.01					---
--- Version: 1.1 [2013.05.23]			---
-------------------------------------------
--- Curse			http://www.curse.com/addons/wow/removecountdown
--- WoWInterface	http://www.wowinterface.com/downloads/info19743-RemoveCountdown.html

local NAME, S = ...
local VERSION = GetAddOnMetadata(NAME, "Version")

local L = S.L

local ACR = LibStub("AceConfigRegistry-3.0")
local ACD = LibStub("AceConfigDialog-3.0")

local db

	--------------------
	--- TimerTracker ---
	--------------------

local function RefreshDB()
	TimerTracker[(db.numbers or db.timerbar) and "RegisterEvent" or "UnregisterEvent"](TimerTracker, "START_TIMER")
end

-- Blizzard provided StartTimer_BarOnlyOnUpdate which
-- apparently is currently unused, but very handy for us
local oldStartTimer_BigNumberOnUpdate = StartTimer_BigNumberOnUpdate

function StartTimer_BigNumberOnUpdate(...)
	if db.timerbar then
		StartTimer_BarOnlyOnUpdate(...)
	else
		oldStartTimer_BigNumberOnUpdate(...)
	end
end

	---------------
	--- Options ---
	---------------

local options = {
	type = "group",
	name = format("%s |cffADFF2Fv%s|r", NAME, VERSION),
	args = {
		inline = {
			type = "group",
			name = " ",
			inline = true,
			args = {
				TimerBar = {
					type = "toggle", order = 1,
					width = "full", descStyle = "",
					name = " "..L.TIMER_BAR,
					get = function(i) return db.timerbar end,
					set = function(i, v) db.timerbar = v; db.numbers = false; RefreshDB() end,
				},
				TimerBarImg = {
					type = "description", order = 2,
					descStyle = "",
					name = "\n|TInterface\\AddOns\\RemoveCountdown\\TimerBar:32:256:20|t\n",
				},
				header = {type = "header", order = 3, name = ""},
				Numbers = {
					type = "toggle", order = 4,
					width = "full", descStyle = "",
					name = " "..L.NUMBERS,
					get = function(i) return db.numbers end,
					set = function(i, v) db.numbers = v; db.timerbar = false; RefreshDB() end,
				},
				NumbersImg = {
					type = "description", order = 5,
					descStyle = "",
					name = "|TInterface\\Timer\\BigTimerNumbers:170:256:20|t",
				},
			},
		},
	},
}

	----------------------
	--- Initialization ---
	----------------------

local function OnEvent(self, event, ...)
	if event == "ADDON_LOADED" then
		local addon = ...
		if addon ~= NAME then return end
		
		RemoveCountdownDB2 = RemoveCountdownDB2 or {}
		db = RemoveCountdownDB2
		ACR:RegisterOptionsTable("RemoveCountdown", options)
		ACD:AddToBlizOptions("RemoveCountdown", NAME)
		ACD:SetDefaultSize("RemoveCountdown", 320, 385)
		RefreshDB()
		self:RegisterEvent("START_TIMER")
		self:UnregisterEvent(event)
	elseif event == "START_TIMER" then
		if not db.numbers then return end
		
		for i = 1, #TimerTracker.timerList do
			_G["TimerTrackerTimer"..i.."StatusBar"]:Hide() -- removes TimerBar
		end
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", OnEvent)

	---------------------
	--- Slash Command ---
	---------------------

for i, v in ipairs({"rmc", "removecount", "removecountdown"}) do
	_G["SLASH_REMOVECOUNTDOWN"..i] = "/"..v
end

SlashCmdList.REMOVECOUNTDOWN = function(msg, editbox)
	ACD:Open("RemoveCountdown")
end
